#include <stdio.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <fcntl.h>

#define N 10
#define MMAP_SIZE N * sizeof(int)
int A[N], *B;
void calcula_posicao(int i);


main() {
  int i, status, fd;

  // iniciar vector A[]
  for (i = 0; i < N; i++)
    A[i] = N - i - 1;

  printf("Vector A[]:\n");
  for (i = 0; i < N; i++)
    printf("%d ", A[i]);
  printf("\n");

  // mapear um ficheiro em memria para representar o vector B[]
  fd = open("mapfile", O_RDWR | O_CREAT | O_TRUNC,  S_IRUSR | S_IWUSR); 
  lseek(fd, MMAP_SIZE, SEEK_SET);
  write(fd, "", 1);
  B = (int *) mmap(0, MMAP_SIZE, PROT_READ|PROT_WRITE, MAP_SHARED, fd, 0);

  for (i = 0; i < N; i++) 
    if (fork() == 0) {
      calcula_posicao(i);
      exit(0);
    }

  // pai espera que todos os filhos terminem
  for (i = 0; i < N; i++)
    wait(&status);

  printf("Vector B[]:\n");
  for (i = 0; i < N; i++)
    printf("%d ", B[i]);
  printf("\n");

  // libertar a regio de memria mapeada
  munmap(B, MMAP_SIZE);
}


void calcula_posicao(int i) {
  int t, j, rank;

  t = A[i];
  rank = 0;
  j = i;
  do {
    j = (j + 1) % N;
    if (t > A[j]) rank++;
  } while (j != i);
  B[rank]= t;
  printf("Filho %d: b[%d] = %d\n", i, rank, t);
}
